Options ls=256 ps=100 nodate pageno=1 NOCENTER;
Data meta0;
length Soiltype$ 40 Design$ 20;
infile 'C:\Meta-analysis(no outlier).csv' 
dlm=',' firstobs=2;
input Data Study EN yield1 yield2 SEM1 SDE SEM2 SDC N1 N2 DFerror Design$ Type$ Species$ Nitro NitroCV$ Years YearCV$ Killdate KillCV$ Soiltype$ Tillage$ State$ Region$ BioOrGrain$ Temp$;
label yield1=control yield2=exp SEM1=exp SEM2=control N1=control N2=exp Temp=(C/Year);
RR=yield2/yield1;
L=log(RR);
VE=(SEM1**2)*N1;
VE1=SDE**2;
VA=(SEM2**2)*N1;
VA1=SDC**2;
YESQ=YIELD1**2;
YASQ=YIELD2**2;
E=1/(N1*YESQ);
A=1/(N2*YASQ);
V=(VE*E)+(VA*A);
V1=(VE1*E)+(VA1*A);
W=1/V;
W1=1/V1;
LSQ=L**2;
WLSQ=W1*LSQ; 
WSQ=W1**2;
WL=L*W1;
WSTAR=1/( V1 +   .008832986);
WSTAR1=1/( V +   .008832986);
*WL=L*WSTAR;
*WSTARLSQ=WSTAR*LSQ;
*if region='GP' then L=.;
run;

PROC PRINT data=meta0; var region L YEARCV;* where region='GP';RUN;

proc univariate data=meta0 normal plot; id data;var  v v1;run;

proc sort data=meta0; by region;
proc means data=meta0 n noprint; by region;var L;
output out=newcount n=count; proc print data=newcount; run;

Proc sort data=meta0; by type;
proc gplot data=meta0; by type;
plot RR*Nitro ;
symbol1 v=dot i=none color=red;
run;quit;


/*BICULTURE*/
data Biculture;
set meta0;
if Type ^='Bi-cultu' then delete;
run; proc print data=Biculture; var Type L V1; run;

/*GRASS*/
data Grass;
set meta0;
if Type ^='Grass' then delete;
run; proc print data=Grass; var Type L V1; run;

/*LEGUME*/
data Legume;
set meta0;
if Type ^='Legume' then delete;
run; proc print data=Legume; var Type L V1; run;

/**** HOMOGENEITY ANALYSIS ****/
PROC SORT DATA=META0; BY TYPE;
TITLE 'WEIGHTED TOTAL SUMS OF SQUARES';
proc mixed data=Meta0 method=type3; weight W1;
model L=  / chisq;
ods output type3=SumsS;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, 35);
run;
proc print data=test; var Source DF SS Qprob; run;

TITLE 'CALCULATING SUMMARY STATISTICS FOR L';
Proc means DATA=meta0 sum mean n ;
var V1 WL W1 WLSQ WSQ L LSQ ;
OUTPUT OUT=COMBINE sum=SV SWL SW SWLSQ SWSQ SD SLSQ  
                  MEAN=MNV MNWD MNW MNWDSQ MNWSQ MND MNDSQ 
				  N = N1 N2 N3 N4 N5 N6 N7 ;PROC PRINT DATA=COMBINE;RUN;
TITLE 'CALCULATING THE VARIANCE BETWEEN STUDIES';
DATA VARBET;
MERGE combine sumss;
N=SS-DF;
CORRW=SWSQ/SW;
UNCORRW=SW;
D=UNCORRW-CORRW;
VAR=N/D;
proc print data=varbet; var var mnv ;
RUN;

proc mixed data=meta0 ;
class data;
model L=;
random data;
run;

TITLE 'SPECIES';
proc mixed data=meta0 method=type3; weight WSTAR;
class type;
model L= type /chisq;
ods output type3=SumsS;
LSMEANS TYPE / CL;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, DF);
run;
proc print data=test; var Source DF SS Qprob; run;

PROC SORT DATA=META0; BY TYPE;
TITLE 'TILLAGE';
proc mixed data=meta0 method=type3; weight WSTAR;
class Tillage;
model L= Tillage ;
ods output type3=SumsS3;
lsmeans tillage / cl;
run;

data test3;
set SumsS3;
Qprob=1-probchi(SS, DF);
run;
proc print data=test3; var Source DF SS Qprob; run;

TITLE 'KILLDATE';
proc mixed data=meta0 method=type3; weight WSTAR;
class KILLCV;
model L= KILLCV ;
ods output type3=SumsS5;
lsmeans killCV / cl;
run;

data test5;
set SumsS5;
Qprob=1-probchi(SS, DF);
run;
proc print data=test5; var Source DF SS Qprob; run;

TITLE 'NITRO';
proc mixed data=meta0 method=type3; weight WSTAR;
class NitroCV;
model L= NitroCV ;
ods output type3=SumsS4;
lsmeans nitroCV /cl;
run;

data test4;
set SumsS4;
Qprob=1-probchi(SS, DF);
run;
proc print data=test4; var Source DF SS Qprob; run;

TITLE 'GRAINORBIO';
proc mixed data=meta0 method=type3; weight WSTAR;
class BIOORGRAIN;
model L= BIOORGRAIN ;
ods output type3=SumsS4;
lsmeans BIOORGRAIN /cl;
run;

data test4;
set SumsS4;
Qprob=1-probchi(SS, DF);
run;
proc print data=test4; var Source DF SS Qprob; run;

TITLE 'REGION';
proc mixed data=meta0 method=type3; weight WSTAR;
class REGION;
model L= REGION ;
ods output type3=SumsS4;
lsmeans REGION /cl;
run;

data test4;
set SumsS4;
Qprob=1-probchi(SS, DF);
run;
proc print data=test4; var Source DF SS Qprob; run;

TITLE 'YEARS';
proc mixed data=meta0 method=type3; weight WSTAR;
class YEARCV;
model L= YEARCV ;
ods output type3=SumsS4;
lsmeans YEARCV /cl;
run;

data test4;
set SumsS4;
Qprob=1-probchi(SS, DF);
run;
proc print data=test4; var Source DF SS Qprob; run;

TITLE 'COMPLETE TOTAL ANOVA';
proc mixed data=meta0 method=type3; weight WSTAR;
class type NITRO TILLAGE KILLDATE;
model L= type NITRO TILLAGE KILLDATE;
ods output type3=SumsS;
LSMEANS TYPE / CL;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, DF);
run;
proc print data=test; var Source DF SS Qprob; run;

proc freq data=meta0;
tables EN;
run;





