Options ls=256 ps=100 nodate pageno=1 NOCENTER;
Data meta0;
length Soiltype$ 40 Design$ 20;
infile 'C:\Meta-analysis.csv' 
dlm=',' firstobs=2;
input Data Study EN yield1 yield2 SEM1 SDE SEM2 SDC N1 N2 DFerror Design$ Type$ Species$ Nitro Years Killdate Soiltype$ Tillage$ State$ BioOrGrain$ Temp$;
label yield1=control yield2=exp SEM1=exp SEM2=control N1=control N2=exp Temp=(C/Year);
/*CODING
If killdate<=6 then killdate='0-6';
If 6<killdate<=13 then killdate='7-13';
If 13<killdate<=19 then killdate='14-19';
If killdate>19 then killdate=' >19';
If nitro<=50 then nitro='0-50';
If 50<nitro<=100 then nitro='50-100';
If 100<nitro<=150 then nitro='100-150';
If 150<nitro<=200 then nitro='150-200';
If 200<nitro<=250 then nitro='200-250';
If 250<nitro<=300 then nitro='250-300';
/*CODING*/
RR=yield2/yield1;
L=log(RR);
VE=(SEM1**2)*N1;
VE1=SDE**2;
VA=(SEM2**2)*N1;
VA1=SDC**2;
YESQ=YIELD1**2;
YASQ=YIELD2**2;
E=1/(N1*YESQ);
A=1/(N2*YASQ);
V=(VE*E)+(VA*A);
V1=(VE1*E)+(VA1*A);
W=1/V;
W1=1/V1;
LSQ=L**2;
WLSQ=W1*LSQ; 
WSQ=W1**2;
WL=L*W1;
WSTAR=1/( V1 +  0.008642197);

*WL=L*WSTAR;
*WSTARLSQ=WSTAR*LSQ;
run;PROC PRINT data=meta0; var L NITRO;RUN;

proc univariate data=meta0 normal plot; id data;var  v v1;run;

/**** HOMOGENEITY ANALYSIS ****/
TITLE 'WEIGHTED TOTAL SUMS OF SQUARES';
proc mixed data=Meta0 method=type3; weight W1;
model L=  / chisq;
ods output type3=SumsS;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, 35);
run;
proc print data=test; var Source DF SS Qprob; run;

TITLE 'CALCULATING SUMMARY STATISTICS FOR L';
Proc means DATA=meta0 sum mean n ;
var V1 WL W1 WLSQ WSQ L LSQ ;
OUTPUT OUT=COMBINE sum=SV SWL SW SWLSQ SWSQ SD SLSQ  
                  MEAN=MNV MNWD MNW MNWDSQ MNWSQ MND MNDSQ 
				  N = N1 N2 N3 N4 N5 N6 N7 ;PROC PRINT DATA=COMBINE;RUN;
TITLE 'CALCULATING THE VARIANCE BETWEEN STUDIES';
DATA VARBET;
MERGE combine sumss;
N=SS-DF;
CORRW=SWSQ/SW;
UNCORRW=SW;
D=UNCORRW-CORRW;
VAR=N/D;
proc print data=varbet; var var mnv ;
RUN;

proc mixed data=meta0 ;
class data;
model L=;
random data;
run;

TITLE 'SPECIES';
proc mixed data=meta0 method=type3; weight WSTAR;
class type;
model L= type;
ods output type3=SumsS;
LSMEANS TYPE / CL;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, DF);
run;
proc print data=test; var Source DF SS Qprob; run;

PROC SORT DATA=META0; BY TYPE;
TITLE 'TILLAGE';
proc mixed data=meta0 method=type3; weight WSTAR;BY TYPE;
class Tillage;
model L= Tillage ;
ods output type3=SumsS3;
lsmeans tillage / cl;
run;

data test3;
set SumsS3;
Qprob=1-probchi(SS, DF);
run;
proc print data=test3; var Source DF SS Qprob; run;

TITLE 'KILLDATE';
proc mixed data=meta0 method=type3; weight WSTAR;
class KILLDATE;
model L= KILLDATE ;
ods output type3=SumsS5;
lsmeans killdate / cl;
run;

data test5;
set SumsS5;
Qprob=1-probchi(SS, DF);
run;
proc print data=test5; var Source DF SS Qprob; run;

TITLE 'NITRO';
proc mixed data=meta0 method=type3; weight WSTAR;
class Nitro;
model L= Nitro ;
ods output type3=SumsS4;
run;

data test4;
set SumsS4;
Qprob=1-probchi(SS, DF);
run;
proc print data=test4; var Source DF SS Qprob; run;

TITLE 'COMPLETE TOTAL ANOVA';
proc mixed data=meta0 method=type3; weight WSTAR;
class type NITRO TILLAGE KILLDATE;
model L= type NITRO TILLAGE KILLDATE;
ods output type3=SumsS;
LSMEANS TYPE / CL;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, DF);
run;
proc print data=test; var Source DF SS Qprob; run;





