Options ls=256 ps=100 nodate pageno=1 NOCENTER;
Data meta0;
length Soiltype$ 40 Design$ 20;
infile 'C:\Meta-analysis(no outlier).csv' 
dlm=',' firstobs=2;
input Data Study EN yield1 yield2 SEM1 SDE SEM2 SDC N1 N2 DFerror Design$ Type$ Species$ Nitro NitroCV$ Years Killdate KillCV$ Soiltype$ Tillage$ State$ Region$ BioOrGrain$ Temp$;
label yield1=control yield2=exp SEM1=exp SEM2=control N1=control N2=exp Temp=(C/Year);
/*CODING
If killdate<=6 then killdate='0-6';
If 6<killdate<=13 then killdate='7-13';
If 13<killdate<=19 then killdate='14-19';
If killdate>19 then killdate=' >19';
If nitro<=50 then nitro='0-50';
If 50<nitro<=100 then nitro='50-100';
If 100<nitro<=150 then nitro='100-150';
If 150<nitro<=200 then nitro='150-200';
If 200<nitro<=250 then nitro='200-250';
If 250<nitro<=300 then nitro='250-300';
/*CODING*/
RR=yield2/yield1;
L=log(RR);
VE=(SEM1**2)*N1;
VE1=SDE**2;
VA=(SEM2**2)*N1;
VA1=SDC**2;
YESQ=YIELD1**2;
YASQ=YIELD2**2;
E=1/(N1*YESQ);
A=1/(N2*YASQ);
V=(VE*E)+(VA*A);
V1=(VE1*E)+(VA1*A);
W=1/V;
W1=1/V1;
LSQ=L**2;
WLSQ=W1*LSQ; 
WSQ=W1**2;
WL=L*W1;
WSTAR=1/( V1 +   .008832986);
WSTAR1=1/( V +   .008832986);
*WL=L*WSTAR;
*WSTARLSQ=WSTAR*LSQ;
run;

/*BICULTURE*/
data Biculture;
set meta0;
if Type ^='Bi-cultu' then delete;
run; proc print data=Biculture; var Type L V1 ; run;


TITLE 'HETEROGENEITY ANALYSIS FOR RESPONSE RATIO (L)';

proc mixed data=Biculture method=type3; weight W1;
model L= / chisq;
ods output type3=SumsS;
run;

data test;
set SumsS;
Qprob=1-probchi(SS, DF);
run;
proc print data=test; var Source DF SS Qprob; run;



TITLE 'CALCULATING SUMMARY STATISTICS FOR L';
Proc means DATA=Biculture sum mean n ;
var V1 WL W1 WLSQ WSQ L LSQ ;
OUTPUT OUT=COMBINE sum=SV SWL SW SWLSQ SWSQ SD SLSQ  
                  MEAN=MNV MNWD MNW MNWDSQ MNWSQ MND MNDSQ 
				  N = N1 N2 N3 N4 N5 N6 N7 ;PROC PRINT DATA=COMBINE;RUN;
data combine; 
set combine;
LBAR=SWL/SW; 
STANDERR=SQRT (1/SW);
DLOWBND=LBAR-(1.96*(STANDERR));
DUPPBND=LBAR+(1.96*(STANDERR));
ZTEST=(ABS(LBAR))/STANDERR;
ZPROB=2*(1-(PROBNORM(ZTEST)));
Q=SWLSQ-((SWL**2)/SW);
POFQ = 1-PROBCHI(Q,N1-1);
S2D=(1/(N1-1))*((SLSQ)-((SD**2)/N1));
SIG2DELT=S2D-MNV;
*QVARC=SUMQVC3-((SUMQVC1**2)/SUMQVC2);
*POFQVC=1-PROBCHI(QVARC, N1-1);
*C=(SW-((SWSQ/SW)));
*VARCOMP2=(Q-(N1-1))/C;
proc print;
Title 'COMBINING RESPONSE RATIOS';
VAR LBAR STANDERR DLOWBND DUPPBND ZTEST ZPROB Q POFQ;
RUN;

TITLE 'CALCULATING THE VARIANCE BETWEEN STUDIES';
DATA VARBET;
MERGE combine sumss;
N=SS-DF;
CORRW=SWSQ/SW;
UNCORRW=SW;
D=UNCORRW-CORRW;
VAR=N/D;
proc print data=varbet; var var mnv ;
RUN;
