/*********************** META REGRESSION **********************/
Options ls=256 ps=100 nodate pageno=1 NOCENTER;
Data metareg;
length Soiltype$ 40 Design$ 20;
infile 'C:\Meta-analysis(REG).csv' 
dlm=',' firstobs=2;
input Data Study EN yield1 yield2 SEM1 SDE SEM2 SDC N1 N2 DFerror Design$ Type$ Species$ Nitro NitroCV$ Years Killdate KillCV$ Soiltype$ Tillage$ State$ Region$ BioOrGrain$ Temp$;
label yield1=control yield2=exp SEM1=exp SEM2=control N1=control N2=exp Temp=(C/Year);
RR=yield2/yield1;
L=log(RR);
VE=(SEM1**2);
VE1=SDE**2;
VA=(SEM2**2);
VA1=SDC**2;
YESQ=YIELD1**2;
YASQ=YIELD2**2;
E=1/(N1*YESQ);
A=1/(N2*YASQ);
V=(VE*E)+(VA*A);
V1=(VE1*E)+(VA1*A);
N=((N1-1)*VE)+((N2-1)*VA);
D=(N1+N2-2);
Vp=N/D;
W=1/Vp;
W1=1/V1;
weight=W1/        216.8623237;
LSQ=L**2;
WLSQ=W1*LSQ; 
WSQ=W1**2;
WL=L*W1;
WSTAR=1/( V1 +    0.016772);
*WSTAR1=1/( V +   .008832986);
WLSTAR=L*WSTAR;
WSTARLSQ=WSTAR*LSQ;
IF _N_=99 THEN DELETE;
IF _N_=98 THEN DELETE;
*IF RR>2.2 THEN DELETE;
run;

proc sort data=metareg; by BioOrGrain Type Nitro;
proc means data=metareg mean noprint;var yield2;  by BioOrGrain Type Nitro;
output out=newmeta mean=my;proc print data=newmeta;run;
proc gplot data=newmeta;where BioOrGrain='Grain';
plot my*Nitro=Type;
symbol1 v=dot i=none;
run;quit;

proc gplot data=metareg;
plot L*Nitro=type;
symbol1 v=dot i=none;
run;quit;

PROC MEANS DATA=METAreg MEAN; VAR W1 WEIGHT;RUN;

proc print data=metareg; var study type W1 WEIGHT EN NITRO RR; run;
proc univariate data=metareg normal plot; var RR; qqplot;run;
proc univariate data=metareg normal plot; var L; qqplot;run;
/*** FIRST ANALYSIS ***/
proc mixed data=metareg covtest ic;WEIGHT WEIGHT;
class study type ;
model L = ;run;

/*** FIRST ANALYSIS ***/
proc mixed data=metareg RATIO ic;WEIGHT WEIGHT;
class study type ;
model L = type nitro type*nitro / solution outp=check1 cl;
random intercept nitro / type=un subject=study solution g gcorr;
lsmeans type / at nitro=0 pdiff;
run;

/* calculating an R-square for the model *
Residual     0.009360 / Residual    0.002877

R2 = 0.69*/

proc print data=check1;var L pred resid nitro type;run;
proc univariate data=check1 normal plot; var PRED;id EN;run;
proc gplot data=check1;
plot pred*nitro=type / vref=0 legend;
symbol1 v=dot i=none color=red;
symbol2 v=triangle i=none color=blue;
symbol3 v=square i=none;
run;quit;

proc sort data=check1; by type;
proc gplot data=check1;by type;
plot pred*nitro / vref=0 ;
symbol1 v=dot i=none color=red;
run;quit;

proc sort data=check1; by type;
proc gplot data=check1;BY TYPE;
plot resid*pred / vref=0;
symbol1 v=dot i=none color=black;
run;quit;

proc univariate data=check1 plot; var resid; id EN; run;

proc mixed data=metareg ratio ic ; WEIGHT WEIGHT;
class study type ;
model L = type type*nitro  / noint solution outp=check cl;
random intercept nitro / type=un subject=study solution g gcorr ;
run;

proc print data=check;var L pred resid nitro type;run;
data check2;
set check;
If type='Grass' then adjy=(nitro*0.00042)+Resid -0.02845;
If type='Bi-cultu' then adjy=(0.1556)+(nitro*0.000934)+Resid;
If type='Legume' then adjy=(0.3127)+(nitro*-0.00169)+Resid;
run;proc sort data=check2; by type;proc print data=check2;var adjy pred nitro type;run;
proc gplot data=check2;
plot adjy*nitro=type;
symbol1 v=dot i=none;
run;quit;
proc mixed data=check2;
class type;
model adjy= type nitro type*nitro / solution outp=pre;
*ods output PredictedValues=res;
*ods listing exclude PredictedValues;
run;quit;

proc gplot data=pre;
plot resid*pred / vref=0;
symbol1 v=dot i=none color=black;
run;quit;

proc print data=check3;run;
proc gplot data=check;
plot pred*nitro=type / vref=0 legend;
symbol1 v=dot i=none color=red;
symbol2 v=triangle i=none color=blue;
symbol3 v=square i=none;
run;quit;

proc print data=check; var L pred resid nitro type;run;

proc mixed data=metareg covtest ic;WEIGHT W1;
class study type ;
model L = type nitro type*nitro  / solution outp=check;
*random study;
random intercept nitro / type=un subject=study solution g gcorr;
contrast "grass vs. nocover" type 0 1 -1;
lsmeans type / pdiff;
lsmeans type / at nitro=0 pdiff;
run;

proc mixed data=metareg covtest ic; WEIGHT W1;
class study type ;
model L = type type*nitro  / noint solution outp=check2;
*random study;
random intercept nitro / type=un subject=study solution g gcorr;
*contrast "grass vs. nocover" type 1 0 -1;
*lsmeans type / pdiff;
*lsmeans type / at nitro=0 pdiff;
run;

PROC GPLOT DATA=CHECK1;
PLOT RESID*PRED /VREF=0;
SYMBOL1 V=DOT I=NONE;
RUN;QUIT;

PROC UNIVARIATE DATA=CHECK1 NORMAL PLOT;QQPLOT;VAR RESID;RUN;

proc mixed data=metareg covtest ic;WEIGHT WEIGHT;
class study type ;
model L = type nitro killdate type*nitro type*killdate  / solution outp=check1 cl;
*random study;
random intercept nitro / type=un subject=study solution g gcorr;
contrast "grass vs. nocover" type 0 1 -1;
*lsmeans type*killdate / pdiff;
run;

proc univariate data=metareg;
var RR L V1;
run;

proc print data=check1;run;

proc glm data=check;
class type;
model pred= type type*nitro / solution noint p;
ods output PredictedValues=res;
run;quit;

proc gplot data=res;
plot residual*predicted /vref=0;
symbol1 v=dot i=none;
run;quit;

proc print data=res;run;

proc univariate data=metareg normal plot;
histogram;
qqplot;
var RR L;
id EN;
run;

proc glm data=metareg;
class study type ;
model L= type type*nitro / noint solution;
*random study;
run;quit;


