Options ls=256 ps=100 nodate pageno=1 NOCENTER;
Data meta0;
length Soiltype$ 40 Design$ 20;
infile 'C:\Meta-analysis(no outlier).csv' 
dlm=',' firstobs=2;
input Data Study EN yield1 yield2 SEM1 SDE SEM2 SDC N1 N2 DFerror Design$ Type$ Species$ Nitro NitroCV$ Years Killdate KillCV$ Soiltype$ Tillage$ State$ Region$ BioOrGrain$ Temp$;
label yield1=control yield2=exp SEM1=exp SEM2=control N1=control N2=exp Temp=(C/Year);
RR=yield2/yield1;
L=log(RR);
VE=(SEM1**2)*N1;
VE1=SDE**2;
VA=(SEM2**2)*N1;
VA1=SDC**2;
YESQ=YIELD1**2;
YASQ=YIELD2**2;
E=1/(N1*YESQ);
A=1/(N2*YASQ);
V=(VE*E)+(VA*A);
V1=(VE1*E)+(VA1*A);
W=1/V;
W1=1/V1;
LSQ=L**2;
WLSQ=W1*LSQ; 
WSQ=W1**2;
WL=L*W1;
WSTAR=1/( V1 +   0.032031016);
WSTAR1=1/( V +   .008832986);
WLSTAR=L*WSTAR;
WSTARSQ=WSTAR**2;
WSTARLSQ=WSTAR*LSQ;
run;PROC PRINT DATA=META0; VAR REGION; RUN;

/*REGION NW*/
data NW;
set META0;
if REGION ^='NW' then delete;
run; proc print data=NW; var REGION L V1 WSTARSQ;run;

proc means data=NW sum n;
var WSTAR WSTARSQ;
OUTPUT OUT=COMBINE1 SUM= SWSTAR SWSTARSQ N= N1 N2;
PROC PRINT DATA=COMBINE1;RUN;

DATA CI;
SET COMBINE1;
CORRF=SWSTARSQ/SWSTAR;
CI=SWSTAR-CORRF;
PROC PRINT DATA=CI; VAR CI;RUN;

/*REGION NE*/
data NE;
set META0;
if REGION ^='NE' then delete;
run; proc print data=NE; var REGION L V1 WSTARSQ;run;

proc means data=NE sum n;
var WSTAR WSTARSQ;
OUTPUT OUT=COMBINE2 SUM= SWSTAR SWSTARSQ N= N1 N2;
PROC PRINT DATA=COMBINE2;RUN;

DATA CI2;
SET COMBINE2;
CORRF=SWSTARSQ/SWSTAR;
CI=SWSTAR-CORRF;
PROC PRINT DATA=CI2; VAR CI;RUN;

/*REGION MW*/
data MW;
set META0;
if REGION ^='MW' then delete;
run; proc print data=MW; var REGION L V1 WSTARSQ;run;

proc means data=MW sum n;
var WSTAR WSTARSQ;
OUTPUT OUT=COMBINE3 SUM= SWSTAR SWSTARSQ N= N1 N2;
PROC PRINT DATA=COMBINE3;RUN;

DATA CI3;
SET COMBINE3;
CORRF=SWSTARSQ/SWSTAR;
CI=SWSTAR-CORRF;
PROC PRINT DATA=CI3; VAR CI;RUN;

/*REGION ECAN*/
data ECAN;
set META0;
if REGION ^='ECAN' then delete;
run; proc print data=ECAN; var REGION L V1 WSTARSQ;run;

proc means data=ECAN sum n;
var WSTAR WSTARSQ;
OUTPUT OUT=COMBINE4 SUM= SWSTAR SWSTARSQ N= N1 N2;
PROC PRINT DATA=COMBINE4;RUN;

DATA CI4;
SET COMBINE4;
CORRF=SWSTARSQ/SWSTAR;
CI=SWSTAR-CORRF;
PROC PRINT DATA=CI4; VAR CI;RUN;

/*REGION GP*/
data GP;
set META0;
if REGION ^='GP' then delete;
run; proc print data=GP; var REGION L V1 WSTARSQ;run;

proc means data=GP sum n;
var WSTAR WSTARSQ;
OUTPUT OUT=COMBINE5 SUM= SWSTAR SWSTARSQ N= N1 N2;
PROC PRINT DATA=COMBINE5;RUN;

DATA CI5;
SET COMBINE5;
CORRF=SWSTARSQ/SWSTAR;
CI=SWSTAR-CORRF;
PROC PRINT DATA=CI5; VAR CI;RUN;

/*REGION SE*/
data SE;
set META0;
if REGION ^='SE' then delete;
run; proc print data=SE; var REGION L V1 WSTARSQ;run;

proc means data=SE sum n;
var WSTAR WSTARSQ;
OUTPUT OUT=COMBINE6 SUM= SWSTAR SWSTARSQ N= N1 N2;
PROC PRINT DATA=COMBINE6;RUN;

DATA CI6;
SET COMBINE6;
CORRF=SWSTARSQ/SWSTAR;
CI=SWSTAR-CORRF;
PROC PRINT DATA=CI6; VAR CI;RUN;

DATA ALL;
SET CI CI2 CI3 CI4 CI5;
PROC PRINT DATA=ALL;RUN;

PROC SORT DATA=META0; BY REGION;
proc mixed data=META0 method=type3; weight W1;BY REGION;
model L= ;
ods output type3=SumsS5;
*lsmeans killDATE / cl;
run;

data test5;
set SumsS5;
Qprob=1-probchi(SS, DF);
run;
proc print data=test5; var REGION Source DF SS Qprob; run;

/*SE*/
TITLE 'CALCULATING SUMMARY STATISTICS FOR LSTAR';
Proc means DATA=SE sum mean n ;
var V1 WLSTAR WSTAR WSTARLSQ WSQ L LSQ ;
OUTPUT OUT=COMB2 sum=SV SWLSTAR SWSTAR SWLSQ SWSQ SD SLSQ  
                  MEAN=MNV MNWD MNW MNWDSQ MNWSQ MND MNDSQ 
				  N = N1 N2 N3 N4 N5 N6 N7 ;PROC PRINT DATA=COMB2;RUN;

data comb; 
set comb2;
LBAR=SWLSTAR/SWSTAR; 
STANDERR=SQRT (1/SWSTAR);
DLOWBND=LBAR-(1.96*(STANDERR));
DUPPBND=LBAR+(1.96*(STANDERR));
ZTEST=(ABS(LBAR))/STANDERR;
ZPROB=2*(1-(PROBNORM(ZTEST)));
Q=SWLSQ-((SWLSTAR**2)/SWSTAR);
POFQ = 1-PROBCHI(Q,N1-1);
S2D=(1/(N1-1))*((SLSQ)-((SD**2)/N1));
SIG2DELT=S2D-MNV;
*QVARC=SUMQVC3-((SUMQVC1**2)/SUMQVC2);
*POFQVC=1-PROBCHI(QVARC, N1-1);
*C=(SW-((SWSQ/SW)));
*VARCOMP2=(Q-(N1-1))/C;
proc print;
Title 'COMBINING RESPONSE RATIOS';
VAR LBAR STANDERR DLOWBND DUPPBND ZTEST ZPROB Q POFQ;
RUN;
